Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -1492,49 +1476,49 @@
       IF (cvflag_prec_eject) THEN
         DO i = 1, ncum
-          IF (k>=(icbs(i)+1)) THEN                                ! convect3
-!  Specific precipitation (liquid and solid) and ice content 
-!  before ejection of precipitation                                                     !!jygprl
-            elacrit = elcrit*min(max(1.-(tp(i,k)-T0)/Tlcrit, 0.), 1.)                   !!jygprl
-!!!!            qcld(i,k) = min(clw(i,k), elacrit)                                          !!jygprl
-            qhthreshold = elacrit*(1.-qta(i,k-1))/(1.-elacrit)
-            qcld(i,k) = min(clw(i,k), qhthreshold)             !!jygprl
-!!!!            phinu2p = max(qhsat(i,k-1) + qcld(i,k-1) - (qhsat(i,k) + qcld(i,k)),0.)   !!jygprl
-            phinu2p = max(clw(i,k) - max(qta(i,k-1) - qhsat(i,k-1), qhthreshold), 0.)
-            qpl(i,k) = qpl(i,k-1) + (1.-frac(i,k))*phinu2p                            !!jygprl
-            qps(i,k) = qps(i,k-1) + frac(i,k)     *phinu2p                            !!jygprl
-            qi(i,k) = (1.-ejectliq)*clw(i,k)*frac(i,k) + &                            !!jygprl
-                     ejectliq*(qps(i,k-1) + frac(i,k)*(phinu2p+qcld(i,k)))            !!jygprl
-!!
-!  =====================================================================================
-!  Ejection of precipitation from adiabatic ascents if requested (cvflag_prec_eject=True):
-!  Compute the steps of total water (qta), of moist static energy (ha), of specific 
-!  precipitation (qpl and qps) and of specific cloud water (qcld) associated with precipitation
-!   ejection.
-!  =====================================================================================
-
-!   Verif
-            qpreca(i,k) = ejectliq*qpl(i,k) + ejectice*qps(i,k)                                   !!jygprl
-            frac_a(i,k) = ejectice*qps(i,k)/max(qpreca(i,k),smallestreal)                         !!jygprl
-            frac_s(i,k) = (1.-ejectliq)*frac(i,k) + &                                             !!jygprl
-               ejectliq*(1. - (qpl(i,k)+(1.-frac(i,k))*qcld(i,k))/max(clw(i,k),smallestreal))     !!jygprl
-
-            denomm1 = 1./(1. - qpreca(i,k))
-
-            qta(i,k) = qta(i,k-1) - &
-                      qpreca(i,k)*(1.-qta(i,k-1))*denomm1
-            ha(i,k)  = ha(i,k-1) + &
-                      ( qpreca(i,k)*(-(1.-qta(i,k-1))*(cl-cpd)*tp(i,k) + &
-                                  lv(i,k)*qhsat(i,k) - lf(i,k)*(frac_s(i,k)*qcld(i,k)+qps(i,k))) + &
-                        lf(i,k)*ejectice*qps(i,k))*denomm1
-            hla(i,k) = hla(i,k-1) + &
-                      ( qpreca(i,k)*(-(1.-qta(i,k-1))*(cpv-cpd)*tp(i,k) - &
-                                  lv(i,k)*((1.-frac_s(i,k))*qcld(i,k)+qpl(i,k)) - &
-                                  (lv(i,k)+lf(i,k))*(frac_s(i,k)*qcld(i,k)+qps(i,k))) + &
-                        lv(i,k)*ejectliq*qpl(i,k) + (lv(i,k)+lf(i,k))*ejectice*qps(i,k))*denomm1
-            qpl(i,k) = qpl(i,k)*(1.-ejectliq)*denomm1
-            qps(i,k) = qps(i,k)*(1.-ejectice)*denomm1
-            qcld(i,k) = qcld(i,k)*denomm1
-            qhsat(i,k) = qhsat(i,k)*(1.-qta(i,k))/(1.-qta(i,k-1))
-         END IF ! (k>=(icbs(i)+1))
+          IF (k>=(icbs(i) + 1)) THEN                                ! convect3
+            !  Specific precipitation (liquid and solid) and ice content
+            !  before ejection of precipitation                                                     !!jygprl
+            elacrit = elcrit * min(max(1. - (tp(i, k) - T0) / Tlcrit, 0.), 1.)                   !!jygprl
+            !!!!            qcld(i,k) = min(clw(i,k), elacrit)                                          !!jygprl
+            qhthreshold = elacrit * (1. - qta(i, k - 1)) / (1. - elacrit)
+            qcld(i, k) = min(clw(i, k), qhthreshold)             !!jygprl
+            !!!!            phinu2p = max(qhsat(i,k-1) + qcld(i,k-1) - (qhsat(i,k) + qcld(i,k)),0.)   !!jygprl
+            phinu2p = max(clw(i, k) - max(qta(i, k - 1) - qhsat(i, k - 1), qhthreshold), 0.)
+            qpl(i, k) = qpl(i, k - 1) + (1. - frac(i, k)) * phinu2p                            !!jygprl
+            qps(i, k) = qps(i, k - 1) + frac(i, k) * phinu2p                            !!jygprl
+            qi(i, k) = (1. - ejectliq) * clw(i, k) * frac(i, k) + &                            !!jygprl
+                    ejectliq * (qps(i, k - 1) + frac(i, k) * (phinu2p + qcld(i, k)))            !!jygprl
+            !!
+            !  =====================================================================================
+            !  Ejection of precipitation from adiabatic ascents if requested (cvflag_prec_eject=True):
+            !  Compute the steps of total water (qta), of moist static energy (ha), of specific
+            !  precipitation (qpl and qps) and of specific cloud water (qcld) associated with precipitation
+            !   ejection.
+            !  =====================================================================================
+
+            !   Verif
+            qpreca(i, k) = ejectliq * qpl(i, k) + ejectice * qps(i, k)                                   !!jygprl
+            frac_a(i, k) = ejectice * qps(i, k) / max(qpreca(i, k), smallestreal)                         !!jygprl
+            frac_s(i, k) = (1. - ejectliq) * frac(i, k) + &                                             !!jygprl
+                    ejectliq * (1. - (qpl(i, k) + (1. - frac(i, k)) * qcld(i, k)) / max(clw(i, k), smallestreal))     !!jygprl
+
+            denomm1 = 1. / (1. - qpreca(i, k))
+
+            qta(i, k) = qta(i, k - 1) - &
+                    qpreca(i, k) * (1. - qta(i, k - 1)) * denomm1
+            ha(i, k) = ha(i, k - 1) + &
+                    (qpreca(i, k) * (-(1. - qta(i, k - 1)) * (cl - cpd) * tp(i, k) + &
+                            lv(i, k) * qhsat(i, k) - lf(i, k) * (frac_s(i, k) * qcld(i, k) + qps(i, k))) + &
+                            lf(i, k) * ejectice * qps(i, k)) * denomm1
+            hla(i, k) = hla(i, k - 1) + &
+                    (qpreca(i, k) * (-(1. - qta(i, k - 1)) * (cpv - cpd) * tp(i, k) - &
+                            lv(i, k) * ((1. - frac_s(i, k)) * qcld(i, k) + qpl(i, k)) - &
+                            (lv(i, k) + lf(i, k)) * (frac_s(i, k) * qcld(i, k) + qps(i, k))) + &
+                            lv(i, k) * ejectliq * qpl(i, k) + (lv(i, k) + lf(i, k)) * ejectice * qps(i, k)) * denomm1
+            qpl(i, k) = qpl(i, k) * (1. - ejectliq) * denomm1
+            qps(i, k) = qps(i, k) * (1. - ejectice) * denomm1
+            qcld(i, k) = qcld(i, k) * denomm1
+            qhsat(i, k) = qhsat(i, k) * (1. - qta(i, k)) / (1. - qta(i, k - 1))
+          END IF ! (k>=(icbs(i)+1))
         END DO ! i = 1, ncum
       ENDIF  ! (cvflag_prec_eject)
@@ -1542,188 +1526,188 @@
     END DO ! k = minorig + 1, nl
 
-!----------------------------------------------------------------------------
+    !----------------------------------------------------------------------------
 
   ELSE IF (icvflag_Tpa == 0) THEN! (icvflag_Tpa == 2) ELSE IF(icvflag_Tpa == 1)
 
-!----------------------------------------------------------------------------
-
-  DO k = minorig + 1, nl
-    DO i = 1, ncum
-! ori	    IF(k.ge.(icb(i)+1))THEN
-      IF (k>=(icbs(i)+1)) THEN                                ! convect3
-        tg = t(i, k)
-        qg = qs(i, k)
-! debug	      alv=lv0-clmcpv*(t(i,k)-t0)
-        alv = lv0 - clmcpv*(t(i,k)-273.15)
-
-! First iteration.
-
-! ori	       s=cpd+alv*alv*qg/(rrv*t(i,k)*t(i,k))
-        s = cpd*(1.-qnk(i)) + cl*qnk(i) + &                   ! convect3
-            alv*alv*qg/(rrv*t(i,k)*t(i,k))                    ! convect3
-        s = 1./s
-! ori	       ahg=cpd*tg+(cl-cpd)*qnk(i)*t(i,k)+alv*qg+gz(i,k)
-        ahg = cpd*tg + (cl-cpd)*qnk(i)*tg + alv*qg + gz(i, k) ! convect3
-        tg = tg + s*(ah0(i)-ahg)
-! ori	       tg=max(tg,35.0)
-! debug	       tc=tg-t0
-        tc = tg - 273.15
-        denom = 243.5 + tc
-        denom = max(denom, 1.0)                               ! convect3
-! ori	       IF(tc.ge.0.0)THEN
-        es = 6.112*exp(17.67*tc/denom)
-! ori	       else
-! ori			es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
-! ori	       endif
-        qg = eps*es/(p(i,k)-es*(1.-eps))
-
-! Second iteration.
-
-! ori	       s=cpd+alv*alv*qg/(rrv*t(i,k)*t(i,k))
-! ori	       s=1./s
-! ori	       ahg=cpd*tg+(cl-cpd)*qnk(i)*t(i,k)+alv*qg+gz(i,k)
-        ahg = cpd*tg + (cl-cpd)*qnk(i)*tg + alv*qg + gz(i, k) ! convect3
-        tg = tg + s*(ah0(i)-ahg)
-! ori	       tg=max(tg,35.0)
-! debug	       tc=tg-t0
-        tc = tg - 273.15
-        denom = 243.5 + tc
-        denom = max(denom, 1.0)                               ! convect3
-! ori	       IF(tc.ge.0.0)THEN
-        es = 6.112*exp(17.67*tc/denom)
-! ori	       else
-! ori			es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
-! ori	       endif
-        qg = eps*es/(p(i,k)-es*(1.-eps))
-
-! debug	       alv=lv0-clmcpv*(t(i,k)-t0)
-        alv = lv0 - clmcpv*(t(i,k)-273.15)
-! PRINT*,'cpd dans convect2 ',cpd
-! PRINT*,'tp(i,k),ah0(i),cl,cpd,qnk(i),t(i,k),gz(i,k),alv,qg,cpd'
-! PRINT*,tp(i,k),ah0(i),cl,cpd,qnk(i),t(i,k),gz(i,k),alv,qg,cpd
-
-! ori c approximation here:
-! ori        tp(i,k)=(ah0(i)-(cl-cpd)*qnk(i)*t(i,k)-gz(i,k)-alv*qg)/cpd
-
-! convect3: no approximation:
-        IF (cvflag_ice) THEN
-          tp(i, k) = max(0., (ah0(i)-gz(i,k)-alv*qg)/(cpd+(cl-cpd)*qnk(i)))
-        ELSE
-          tp(i, k) = (ah0(i)-gz(i,k)-alv*qg)/(cpd+(cl-cpd)*qnk(i))
-        END IF
-
-        clw(i, k) = qnk(i) - qg
-        clw(i, k) = max(0.0, clw(i,k))
-        rg = qg/(1.-qnk(i))
-! ori               tvp(i,k)=tp(i,k)*(1.+rg*epsi)
-! convect3: (qg utilise au lieu du vrai mixing ratio rg):
-        tvp(i, k) = tp(i, k)*(1.+qg/eps-qnk(i)) ! whole thing
-        IF (cvflag_ice) THEN
-          IF (clw(i,k)<1.E-11) THEN
-            tp(i, k) = tv(i, k)
-            tvp(i, k) = tv(i, k)
+    !----------------------------------------------------------------------------
+
+    DO k = minorig + 1, nl
+      DO i = 1, ncum
+        ! ori	    IF(k.ge.(icb(i)+1))THEN
+        IF (k>=(icbs(i) + 1)) THEN                                ! convect3
+          tg = t(i, k)
+          qg = qs(i, k)
+          ! debug	      alv=lv0-clmcpv*(t(i,k)-t0)
+          alv = lv0 - clmcpv * (t(i, k) - 273.15)
+
+          ! First iteration.
+
+          ! ori	       s=cpd+alv*alv*qg/(rrv*t(i,k)*t(i,k))
+          s = cpd * (1. - qnk(i)) + cl * qnk(i) + &                   ! convect3
+                  alv * alv * qg / (rrv * t(i, k) * t(i, k))                    ! convect3
+          s = 1. / s
+          ! ori	       ahg=cpd*tg+(cl-cpd)*qnk(i)*t(i,k)+alv*qg+gz(i,k)
+          ahg = cpd * tg + (cl - cpd) * qnk(i) * tg + alv * qg + gz(i, k) ! convect3
+          tg = tg + s * (ah0(i) - ahg)
+          ! ori	       tg=max(tg,35.0)
+          ! debug	       tc=tg-t0
+          tc = tg - 273.15
+          denom = 243.5 + tc
+          denom = max(denom, 1.0)                               ! convect3
+          ! ori	       IF(tc.ge.0.0)THEN
+          es = 6.112 * exp(17.67 * tc / denom)
+          ! ori	       else
+          ! ori			es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
+          ! ori	       endif
+          qg = eps * es / (p(i, k) - es * (1. - eps))
+
+          ! Second iteration.
+
+          ! ori	       s=cpd+alv*alv*qg/(rrv*t(i,k)*t(i,k))
+          ! ori	       s=1./s
+          ! ori	       ahg=cpd*tg+(cl-cpd)*qnk(i)*t(i,k)+alv*qg+gz(i,k)
+          ahg = cpd * tg + (cl - cpd) * qnk(i) * tg + alv * qg + gz(i, k) ! convect3
+          tg = tg + s * (ah0(i) - ahg)
+          ! ori	       tg=max(tg,35.0)
+          ! debug	       tc=tg-t0
+          tc = tg - 273.15
+          denom = 243.5 + tc
+          denom = max(denom, 1.0)                               ! convect3
+          ! ori	       IF(tc.ge.0.0)THEN
+          es = 6.112 * exp(17.67 * tc / denom)
+          ! ori	       else
+          ! ori			es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
+          ! ori	       endif
+          qg = eps * es / (p(i, k) - es * (1. - eps))
+
+          ! debug	       alv=lv0-clmcpv*(t(i,k)-t0)
+          alv = lv0 - clmcpv * (t(i, k) - 273.15)
+          ! PRINT*,'cpd dans convect2 ',cpd
+          ! PRINT*,'tp(i,k),ah0(i),cl,cpd,qnk(i),t(i,k),gz(i,k),alv,qg,cpd'
+          ! PRINT*,tp(i,k),ah0(i),cl,cpd,qnk(i),t(i,k),gz(i,k),alv,qg,cpd
+
+          ! ori c approximation here:
+          ! ori        tp(i,k)=(ah0(i)-(cl-cpd)*qnk(i)*t(i,k)-gz(i,k)-alv*qg)/cpd
+
+          ! convect3: no approximation:
+          IF (cvflag_ice) THEN
+            tp(i, k) = max(0., (ah0(i) - gz(i, k) - alv * qg) / (cpd + (cl - cpd) * qnk(i)))
+          ELSE
+            tp(i, k) = (ah0(i) - gz(i, k) - alv * qg) / (cpd + (cl - cpd) * qnk(i))
           END IF
-        END IF
-!jyg<
-!!      END IF  ! Endif moved to the end of the loop
-!>jyg
-
-      IF (cvflag_ice) THEN
-!CR:attention boucle en klon dans Icefrac
-! Call Icefrac(t,clw,qi,nl,nloc)
-        IF (t(i,k)>263.15) THEN
-          qi(i, k) = 0.
-        ELSE
-          IF (t(i,k)<243.15) THEN
-            qi(i, k) = clw(i, k)
-          ELSE
-            fracg = (263.15-t(i,k))/20
-            qi(i, k) = clw(i, k)*fracg
+
+          clw(i, k) = qnk(i) - qg
+          clw(i, k) = max(0.0, clw(i, k))
+          rg = qg / (1. - qnk(i))
+          ! ori               tvp(i,k)=tp(i,k)*(1.+rg*epsi)
+          ! convect3: (qg utilise au lieu du vrai mixing ratio rg):
+          tvp(i, k) = tp(i, k) * (1. + qg / eps - qnk(i)) ! whole thing
+          IF (cvflag_ice) THEN
+            IF (clw(i, k)<1.E-11) THEN
+              tp(i, k) = tv(i, k)
+              tvp(i, k) = tv(i, k)
+            END IF
           END IF
-        END IF
-!CR: fin test
-        IF (t(i,k)<263.15) THEN
-!CR: on commente les calculs d'Arnaud car division par zero
-! nouveau calcul propose par JYG
-!       alv=lv0-clmcpv*(t(i,k)-273.15)
-!       alf=lf0-clmci*(t(i,k)-273.15)
-!       tg=tp(i,k)
-!       tc=tp(i,k)-273.15
-!       denom=243.5+tc
-!       do j=1,3
-! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-! il faudra que esi vienne en argument de la convection
-! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-!        tbis=t(i,k)+(tp(i,k)-tg)
-!        esi=exp(23.33086-(6111.72784/tbis) + &
-!                       0.15215*log(tbis))
-!        qsat_new=eps*esi/(p(i,k)-esi*(1.-eps))
-!        snew=cpd*(1.-qnk(i))+cl*qnk(i)+alv*alv*qsat_new/ &
-!                                       (rrv*tbis*tbis)
-!        snew=1./snew
-!        PRINT*,esi,qsat_new,snew,'esi,qsat,snew'
-!        tp(i,k)=tg+(alf*qi(i,k)+alv*qg*(1.-(esi/es)))*snew
-!        PRINT*,k,tp(i,k),qnk(i),'avec glace'
-!        PRINT*,'tpNAN',tg,alf,qi(i,k),alv,qg,esi,es,snew
-!       enddo
-
-          alv = lv0 - clmcpv*(t(i,k)-273.15)
-          alf = lf0 + clmci*(t(i,k)-273.15)
-          als = alf + alv
-          tg = tp(i, k)
-          tp(i, k) = t(i, k)
-          DO j = 1, 3
-            esi = exp(23.33086-(6111.72784/tp(i,k))+0.15215*log(tp(i,k)))
-            qsat_new = eps*esi/(p(i,k)-esi*(1.-eps))
-            snew = cpd*(1.-qnk(i)) + cl*qnk(i) + alv*als*qsat_new/ &
-                                                 (rrv*tp(i,k)*tp(i,k))
-            snew = 1./snew
-! c             PRINT*,esi,qsat_new,snew,'esi,qsat,snew'
-            tp(i, k) = tp(i, k) + &
-                       ((cpd*(1.-qnk(i))+cl*qnk(i))*(tg-tp(i,k)) + &
-                        alv*(qg-qsat_new)+alf*qi(i,k))*snew
-! PRINT*,k,tp(i,k),qsat_new,qnk(i),qi(i,k), &
-!              'k,tp,q,qt,qi avec glace'
-          END DO
-
-!CR:reprise du code AJ
-          clw(i, k) = qnk(i) - qsat_new
-          clw(i, k) = max(0.0, clw(i,k))
-          tvp(i, k) = max(0., tp(i,k)*(1.+qsat_new/eps-qnk(i)))
-! PRINT*,tvp(i,k),'tvp'
-        END IF
-        IF (clw(i,k)<1.E-11) THEN
-          tp(i, k) = tv(i, k)
-          tvp(i, k) = tv(i, k)
-        END IF
-      END IF ! (cvflag_ice)
-!jyg<
-      END IF ! (k>=(icbs(i)+1))
-!>jyg
-    END DO
-  END DO
-
-!----------------------------------------------------------------------------
+          !jyg<
+          !!      END IF  ! Endif moved to the end of the loop
+          !>jyg
+
+          IF (cvflag_ice) THEN
+            !CR:attention boucle en klon dans Icefrac
+            ! Call Icefrac(t,clw,qi,nl,nloc)
+            IF (t(i, k)>263.15) THEN
+              qi(i, k) = 0.
+            ELSE
+              IF (t(i, k)<243.15) THEN
+                qi(i, k) = clw(i, k)
+              ELSE
+                fracg = (263.15 - t(i, k)) / 20
+                qi(i, k) = clw(i, k) * fracg
+              END IF
+            END IF
+            !CR: fin test
+            IF (t(i, k)<263.15) THEN
+              !CR: on commente les calculs d'Arnaud car division par zero
+              ! nouveau calcul propose par JYG
+              !       alv=lv0-clmcpv*(t(i,k)-273.15)
+              !       alf=lf0-clmci*(t(i,k)-273.15)
+              !       tg=tp(i,k)
+              !       tc=tp(i,k)-273.15
+              !       denom=243.5+tc
+              !       do j=1,3
+              ! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+              ! il faudra que esi vienne en argument de la convection
+              ! cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+              !        tbis=t(i,k)+(tp(i,k)-tg)
+              !        esi=exp(23.33086-(6111.72784/tbis) + &
+              !                       0.15215*log(tbis))
+              !        qsat_new=eps*esi/(p(i,k)-esi*(1.-eps))
+              !        snew=cpd*(1.-qnk(i))+cl*qnk(i)+alv*alv*qsat_new/ &
+              !                                       (rrv*tbis*tbis)
+              !        snew=1./snew
+              !        PRINT*,esi,qsat_new,snew,'esi,qsat,snew'
+              !        tp(i,k)=tg+(alf*qi(i,k)+alv*qg*(1.-(esi/es)))*snew
+              !        PRINT*,k,tp(i,k),qnk(i),'avec glace'
+              !        PRINT*,'tpNAN',tg,alf,qi(i,k),alv,qg,esi,es,snew
+              !       enddo
+
+              alv = lv0 - clmcpv * (t(i, k) - 273.15)
+              alf = lf0 + clmci * (t(i, k) - 273.15)
+              als = alf + alv
+              tg = tp(i, k)
+              tp(i, k) = t(i, k)
+              DO j = 1, 3
+                esi = exp(23.33086 - (6111.72784 / tp(i, k)) + 0.15215 * log(tp(i, k)))
+                qsat_new = eps * esi / (p(i, k) - esi * (1. - eps))
+                snew = cpd * (1. - qnk(i)) + cl * qnk(i) + alv * als * qsat_new / &
+                        (rrv * tp(i, k) * tp(i, k))
+                snew = 1. / snew
+                ! c             PRINT*,esi,qsat_new,snew,'esi,qsat,snew'
+                tp(i, k) = tp(i, k) + &
+                        ((cpd * (1. - qnk(i)) + cl * qnk(i)) * (tg - tp(i, k)) + &
+                                alv * (qg - qsat_new) + alf * qi(i, k)) * snew
+                ! PRINT*,k,tp(i,k),qsat_new,qnk(i),qi(i,k), &
+                !              'k,tp,q,qt,qi avec glace'
+              END DO
+
+              !CR:reprise du code AJ
+              clw(i, k) = qnk(i) - qsat_new
+              clw(i, k) = max(0.0, clw(i, k))
+              tvp(i, k) = max(0., tp(i, k) * (1. + qsat_new / eps - qnk(i)))
+              ! PRINT*,tvp(i,k),'tvp'
+            END IF
+            IF (clw(i, k)<1.E-11) THEN
+              tp(i, k) = tv(i, k)
+              tvp(i, k) = tv(i, k)
+            END IF
+          END IF ! (cvflag_ice)
+          !jyg<
+        END IF ! (k>=(icbs(i)+1))
+        !>jyg
+      END DO
+    END DO
+
+    !----------------------------------------------------------------------------
 
   ENDIF ! (icvflag_Tpa == 2) ELSEIF (icvflag_Tpa == 1) ELSE (icvflag_Tpa == 0)
 
-!----------------------------------------------------------------------------
-
-! =====================================================================
-! --- SET THE PRECIPITATION EFFICIENCIES 
-! --- THESE MAY BE FUNCTIONS OF TP(I), P(I) AND CLW(I)
-! =====================================================================
+  !----------------------------------------------------------------------------
+
+  ! =====================================================================
+  ! --- SET THE PRECIPITATION EFFICIENCIES
+  ! --- THESE MAY BE FUNCTIONS OF TP(I), P(I) AND CLW(I)
+  ! =====================================================================
 
   IF (flag_epkeorig/=1) THEN
     DO k = 1, nl ! convect3
       DO i = 1, ncum
-!jyg<
-       IF(k>=icb(i)) THEN
-!>jyg
-         pden = ptcrit - pbcrit
-         ep(i, k) = (plcl(i)-p(i,k)-pbcrit)/pden*epmax
-         ep(i, k) = max(ep(i,k), 0.0)
-         ep(i, k) = min(ep(i,k), epmax)
-!!         sigp(i, k) = spfac  ! jyg
+        !jyg<
+        IF(k>=icb(i)) THEN
+          !>jyg
+          pden = ptcrit - pbcrit
+          ep(i, k) = (plcl(i) - p(i, k) - pbcrit) / pden * epmax
+          ep(i, k) = max(ep(i, k), 0.0)
+          ep(i, k) = min(ep(i, k), epmax)
+          !!         sigp(i, k) = spfac  ! jyg
         ENDIF   ! (k>=icb(i))
       END DO
@@ -1733,17 +1717,17 @@
       DO i = 1, ncum
         IF(k>=icb(i)) THEN
-!!        IF (k>=(nk(i)+1)) THEN
-!>jyg
+          !!        IF (k>=(nk(i)+1)) THEN
+          !>jyg
           tca = tp(i, k) - t0
           IF (tca>=0.0) THEN
             elacrit = elcrit
           ELSE
-            elacrit = elcrit*(1.0-tca/tlcrit)
+            elacrit = elcrit * (1.0 - tca / tlcrit)
           END IF
           elacrit = max(elacrit, 0.0)
-          ep(i, k) = 1.0 - elacrit/max(clw(i,k), 1.0E-8)
-          ep(i, k) = max(ep(i,k), 0.0)
-          ep(i, k) = min(ep(i,k), epmax)
-!!          sigp(i, k) = spfac  ! jyg
+          ep(i, k) = 1.0 - elacrit / max(clw(i, k), 1.0E-8)
+          ep(i, k) = max(ep(i, k), 0.0)
+          ep(i, k) = min(ep(i, k), epmax)
+          !!          sigp(i, k) = spfac  ! jyg
         END IF  ! (k>=icb(i))
       END DO
@@ -1751,31 +1735,31 @@
   END IF
 
-!   =========================================================================
+  !   =========================================================================
   IF (prt_level >= 10) THEN
-    print *,'cv3_undilute2.1. tp(1,k), tvp(1,k) ', &
-                          (k, tp(1,k), tvp(1,k), k = 1,nl)
+    print *, 'cv3_undilute2.1. tp(1,k), tvp(1,k) ', &
+            (k, tp(1, k), tvp(1, k), k = 1, nl)
   ENDIF
 
-! =====================================================================
-! --- CALCULATE VIRTUAL TEMPERATURE AND LIFTED PARCEL
-! --- VIRTUAL TEMPERATURE
-! =====================================================================
-
-! dans convect3, tvp est calcule en une seule fois, et sans retirer
-! l'eau condensee (~> reversible CAPE)
-
-! ori      do 340 k=minorig+1,nl
-! ori        do 330 i=1,ncum
-! ori        IF(k.ge.(icb(i)+1))THEN
-! ori          tvp(i,k)=tvp(i,k)*(1.0-qnk(i)+ep(i,k)*clw(i,k))
-! oric         PRINT*,'i,k,tvp(i,k),qnk(i),ep(i,k),clw(i,k)'
-! oric         PRINT*, i,k,tvp(i,k),qnk(i),ep(i,k),clw(i,k)
-! ori        endif
-! ori 330    continue
-! ori 340  continue
-
-! ori      do 350 i=1,ncum
-! ori       tvp(i,nlp)=tvp(i,nl)-(gz(i,nlp)-gz(i,nl))/cpd
-! ori 350  continue
+  ! =====================================================================
+  ! --- CALCULATE VIRTUAL TEMPERATURE AND LIFTED PARCEL
+  ! --- VIRTUAL TEMPERATURE
+  ! =====================================================================
+
+  ! dans convect3, tvp est calcule en une seule fois, et sans retirer
+  ! l'eau condensee (~> reversible CAPE)
+
+  ! ori      do 340 k=minorig+1,nl
+  ! ori        do 330 i=1,ncum
+  ! ori        IF(k.ge.(icb(i)+1))THEN
+  ! ori          tvp(i,k)=tvp(i,k)*(1.0-qnk(i)+ep(i,k)*clw(i,k))
+  ! oric         PRINT*,'i,k,tvp(i,k),qnk(i),ep(i,k),clw(i,k)'
+  ! oric         PRINT*, i,k,tvp(i,k),qnk(i),ep(i,k),clw(i,k)
+  ! ori        endif
+  ! ori 330    continue
+  ! ori 340  continue
+
+  ! ori      do 350 i=1,ncum
+  ! ori       tvp(i,nlp)=tvp(i,nl)-(gz(i,nlp)-gz(i,nl))/cpd
+  ! ori 350  continue
 
   DO i = 1, ncum                                           ! convect3
@@ -1783,13 +1767,13 @@
   END DO                                                   ! convect3
 
-! =====================================================================
-! --- EFFECTIVE VERTICAL PROFILE OF BUOYANCY (convect3 only):
-! =====================================================================
-
-! -- this is for convect3 only:
-
-! first estimate of buoyancy:
-
-!jyg : k-loop outside i-loop (07042015)
+  ! =====================================================================
+  ! --- EFFECTIVE VERTICAL PROFILE OF BUOYANCY (convect3 only):
+  ! =====================================================================
+
+  ! -- this is for convect3 only:
+
+  ! first estimate of buoyancy:
+
+  !jyg : k-loop outside i-loop (07042015)
   DO k = 1, nl
     DO i = 1, ncum
@@ -1798,11 +1782,11 @@
   END DO
 
-! set buoyancy=buoybase for all levels below base
-! for safety, set buoy(icb)=buoybase
-
-!jyg : k-loop outside i-loop (07042015)
+  ! set buoyancy=buoybase for all levels below base
+  ! for safety, set buoy(icb)=buoybase
+
+  !jyg : k-loop outside i-loop (07042015)
   DO k = 1, nl
     DO i = 1, ncum
-      IF ((k>=icb(i)) .AND. (k<=nl) .AND. (p(i,k)>=pbase(i))) THEN
+      IF ((k>=icb(i)) .AND. (k<=nl) .AND. (p(i, k)>=pbase(i))) THEN
         buoy(i, k) = buoybase(i)
       END IF
@@ -1810,16 +1794,16 @@
   END DO
   DO i = 1, ncum
-!    buoy(icb(i),k)=buoybase(i)
+    !    buoy(icb(i),k)=buoybase(i)
     buoy(i, icb(i)) = buoybase(i)
   END DO
 
-! -- end convect3
-
-! =====================================================================
-! --- FIND THE FIRST MODEL LEVEL (INB) ABOVE THE PARCEL'S
-! --- LEVEL OF NEUTRAL BUOYANCY
-! =====================================================================
-
-! -- this is for convect3 only:
+  ! -- end convect3
+
+  ! =====================================================================
+  ! --- FIND THE FIRST MODEL LEVEL (INB) ABOVE THE PARCEL'S
+  ! --- LEVEL OF NEUTRAL BUOYANCY
+  ! =====================================================================
+
+  ! -- this is for convect3 only:
 
   DO i = 1, ncum
@@ -1829,8 +1813,8 @@
 
 
-! --    iposit(i) = first level, above icb, with positive buoyancy
+  ! --    iposit(i) = first level, above icb, with positive buoyancy
   DO k = 1, nl - 1
     DO i = 1, ncum
-      IF (k>=icb(i) .AND. buoy(i,k)>0.) THEN
+      IF (k>=icb(i) .AND. buoy(i, k)>0.) THEN
         iposit(i) = min(iposit(i), k)
       END IF
@@ -1846,5 +1830,5 @@
   DO k = 1, nl - 1
     DO i = 1, ncum
-      IF ((k>=iposit(i)) .AND. (buoy(i,k)<dtovsh)) THEN
+      IF ((k>=iposit(i)) .AND. (buoy(i, k)<dtovsh)) THEN
         inb(i) = min(inb(i), k)
       END IF
